# CustomAngleForce Class Reference

This class implements interactions between sets of three particles that depend on the angle between them. More...

`#include <CustomAngleForce.h>`

Inheritance diagram for CustomAngleForce:

List of all members.

## Classes

class | AngleInfo
| This is an internal class used to record information about an angle.
class | AngleParameterInfo
| This is an internal class used to record information about a per-angle parameter.
class | GlobalParameterInfo
| This is an internal class used to record information about a global parameter.

## Public Member Functions

| CustomAngleForce (const std::string &energy)
| Create a CustomAngleForce.
int | getNumAngles () const
| Get the number of angles for which force field parameters have been defined.
int | getNumPerAngleParameters () const
| Get the number of per-angle parameters that the interaction depends on.
int | getNumGlobalParameters () const
| Get the number of global parameters that the interaction depends on.
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the interaction energy for each angle.
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the interaction energy for each angle.
int | addPerAngleParameter (const std::string &name)
| Add a new per-angle parameter that the interaction may depend on.
const std::string & | getPerAngleParameterName (int index) const
| Get the name of a per-angle parameter.
void | setPerAngleParameterName (int index, const std::string &name)
| Set the name of a per-angle parameter.
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the interaction may depend on.
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter.
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter.
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter.
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter.
int | addAngle (int particle1, int particle2, int particle3, const std::vector< double > &parameters)
| Add an angle term to the force field.
void | getAngleParameters (int index, int &particle1, int &particle2, int &particle3, std::vector< double > &parameters) const
| Get the force field parameters for an angle term.
void | setAngleParameters (int index, int particle1, int particle2, int particle3, const std::vector< double > &parameters)
| Set the force field parameters for an angle term.
void | updateParametersInContext (Context &context)
| Update the per-angle parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements interactions between sets of three particles that depend on the angle between them.

Unlike HarmonicAngleForce, the functional form of the interaction is completely customizable, and may involve arbitrary algebraic expressions. In addition to the angle formed by the particles, it may depend on arbitrary global and per-angle parameters.

To use this class, create a CustomAngleForce object, passing an algebraic expression to the constructor that defines the interaction energy between each set of particles. The expression may depend on theta, the angle formed by the particles, as well as on any parameters you choose. Then call addPerAngleParameter() to define per-angle parameters, and addGlobalParameter() to define global parameters. The values of per-angle parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter(). Finally, call addAngle() once for each angle. After an angle has been added, you can modify its parameters by calling setAngleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomAngleForce that implements a harmonic potential:

`CustomAngleForce* force = new CustomAngleForce("0.5*k*(theta-theta0)^2");`

This force depends on two parameters: the spring constant k and equilibrium angle theta0. The following code defines these parameters:

``

     force->addPerAngleParameter("k");
     force->addPerAngleParameter("theta0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

## Constructor & Destructor Documentation

CustomAngleForce | ( | const std::string & | energy | ) | `[explicit]`

Create a CustomAngleForce.

Parameters:

  | energy | an algebraic expression giving the interaction energy between three particles as a function of theta, the angle between them

## Member Function Documentation

int addAngle | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Add an angle term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the angle
  | particle2 | the index of the second particle connected by the angle
  | particle3 | the index of the third particle connected by the angle
  | parameters | the list of parameters for the new angle

Returns:
  the index of the angle that was added

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue |
| ) |  |  |

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

Returns:
  the index of the parameter that was added

int addPerAngleParameter | ( | const std::string & | name | ) |

Add a new per-angle parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

Returns:
  the index of the parameter that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

void getAngleParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | std::vector< double > & | parameters |
| ) |  |  | const

Get the force field parameters for an angle term.

Parameters:

  | index | the index of the angle for which to get parameters
  | particle1 | the index of the first particle connected by the angle
  | particle2 | the index of the second particle connected by the angle
  | particle3 | the index of the third particle connected by the angle
  | parameters | the list of parameters for the angle

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the interaction energy for each angle.

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

Returns:
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

int getNumAngles | ( |  | ) | const`[inline]`

Get the number of angles for which force field parameters have been defined.

int getNumGlobalParameters | ( |  | ) | const`[inline]`

Get the number of global parameters that the interaction depends on.

int getNumPerAngleParameters | ( |  | ) | const`[inline]`

Get the number of per-angle parameters that the interaction depends on.

const std::string& getPerAngleParameterName | ( | int | index | ) | const

Get the name of a per-angle parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

void setAngleParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Set the force field parameters for an angle term.

Parameters:

  | index | the index of the angle for which to set parameters
  | particle1 | the index of the first particle connected by the angle
  | particle2 | the index of the second particle connected by the angle
  | particle3 | the index of the third particle connected by the angle
  | parameters | the list of parameters for the angle

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the interaction energy for each angle.

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue |
| ) |  |  |

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setPerAngleParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a per-angle parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void updateParametersInContext | ( | Context & | context | ) |

Update the per-angle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setAngleParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-angle parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a angle cannot be changed, nor can new angles be added.

The documentation for this class was generated from the following file:

- CustomAngleForce.h